Index: trunk/SophyaProg/PMixer/Sph2Sph.cc
===================================================================
--- trunk/SophyaProg/PMixer/Sph2Sph.cc	(revision 2609)
+++ trunk/SophyaProg/PMixer/Sph2Sph.cc	(revision 2615)
@@ -1,2 +1,3 @@
+#include "sopnamsp.h"
 #include "pmixer.h"
 
Index: trunk/SophyaProg/PMixer/easyTest.cc
===================================================================
--- trunk/SophyaProg/PMixer/easyTest.cc	(revision 2609)
+++ trunk/SophyaProg/PMixer/easyTest.cc	(revision 2615)
@@ -1,3 +1,4 @@
 #include <iostream>
+#include "sopnamsp.h"
 #include "blackbody.h"
 #include "radspecvector.h"
Index: trunk/SophyaProg/PMixer/extractRS.cc
===================================================================
--- trunk/SophyaProg/PMixer/extractRS.cc	(revision 2609)
+++ trunk/SophyaProg/PMixer/extractRS.cc	(revision 2615)
@@ -1,2 +1,3 @@
+#include "sopnamsp.h"
 #include "pmixer.h"
 
Index: trunk/SophyaProg/PMixer/skymixer.cc
===================================================================
--- trunk/SophyaProg/PMixer/skymixer.cc	(revision 2609)
+++ trunk/SophyaProg/PMixer/skymixer.cc	(revision 2615)
@@ -1,2 +1,3 @@
+#include "sopnamsp.h"
 #include "pmixer.h"
 
Index: trunk/SophyaProg/PMixer/tgrsr.cc
===================================================================
--- trunk/SophyaProg/PMixer/tgrsr.cc	(revision 2609)
+++ trunk/SophyaProg/PMixer/tgrsr.cc	(revision 2615)
@@ -1,3 +1,4 @@
 #include <typeinfo>
+#include "sopnamsp.h"
 #include "pmixer.h"
 
Index: trunk/SophyaProg/PMixer/tgsky.cc
===================================================================
--- trunk/SophyaProg/PMixer/tgsky.cc	(revision 2609)
+++ trunk/SophyaProg/PMixer/tgsky.cc	(revision 2615)
@@ -1,2 +1,3 @@
+#include "sopnamsp.h"
 #include "pmixer.h"
 #include "mapoperation.h"
Index: trunk/SophyaProg/PrgMap/cl2map.cc
===================================================================
--- trunk/SophyaProg/PrgMap/cl2map.cc	(revision 2609)
+++ trunk/SophyaProg/PrgMap/cl2map.cc	(revision 2615)
@@ -1,2 +1,3 @@
+#include "sopnamsp.h"
 #include "machdefs.h"    // Definitions specifiques SOPHYA
 
Index: trunk/SophyaProg/PrgMap/cremskfrsph.cc
===================================================================
--- trunk/SophyaProg/PrgMap/cremskfrsph.cc	(revision 2609)
+++ trunk/SophyaProg/PrgMap/cremskfrsph.cc	(revision 2615)
@@ -3,4 +3,5 @@
 // cremskfrsph -m 0.1 -v 1.,0. sph143k05_e.fits sphmskw.fits
 // cremskfrsph -n -m -1.e-30. -M 1.e-30. -v 1.,0. sph143k05.fits sphmsk.fits
+#include "sopnamsp.h"
 #include "machdefs.h"
 #include <unistd.h>
Index: trunk/SophyaProg/PrgMap/extrap2sph.cc
===================================================================
--- trunk/SophyaProg/PrgMap/extrap2sph.cc	(revision 2609)
+++ trunk/SophyaProg/PrgMap/extrap2sph.cc	(revision 2615)
@@ -4,4 +4,5 @@
 // extrap2sph -w sph143k05_e.fits sph143k05.fits sphred.fits sphout_2.fits
 // extrap2sph -m -1.e-30 -M +1.e-30 sph143k05.fits sphred.fits sphout_22.fits
+#include "sopnamsp.h"
 #include "machdefs.h"
 #include <unistd.h>
Index: trunk/SophyaProg/PrgMap/extrapsph.cc
===================================================================
--- trunk/SophyaProg/PrgMap/extrapsph.cc	(revision 2609)
+++ trunk/SophyaProg/PrgMap/extrapsph.cc	(revision 2615)
@@ -4,4 +4,5 @@
 // extrapsph -r 2 sph143k05.fits sph143k05_e.fits
 //                sphout.fits sphoutw.fits sphred.fits sphredw.fits
+#include "sopnamsp.h"
 #include "machdefs.h"
 #include <unistd.h>
Index: trunk/SophyaProg/PrgMap/map2cl.cc
===================================================================
--- trunk/SophyaProg/PrgMap/map2cl.cc	(revision 2609)
+++ trunk/SophyaProg/PrgMap/map2cl.cc	(revision 2615)
@@ -1,2 +1,3 @@
+#include "sopnamsp.h"
 #include "machdefs.h"    // Definitions specifiques SOPHYA
 
Index: trunk/SophyaProg/PrgMap/msksphere.cc
===================================================================
--- trunk/SophyaProg/PrgMap/msksphere.cc	(revision 2609)
+++ trunk/SophyaProg/PrgMap/msksphere.cc	(revision 2615)
@@ -1,4 +1,5 @@
 // Creation d'une sphere de masquee a partir d'une sphere de masques
 //         cmv 15/6/01
+#include "sopnamsp.h"
 #include "machdefs.h"
 #include <unistd.h>
Index: trunk/SophyaProg/PrgMap/prjsmap.cc
===================================================================
--- trunk/SophyaProg/PrgMap/prjsmap.cc	(revision 2609)
+++ trunk/SophyaProg/PrgMap/prjsmap.cc	(revision 2615)
@@ -1,2 +1,3 @@
+#include "sopnamsp.h"
 #include "machdefs.h"    // Definitions specifiques SOPHYA
 
Index: trunk/SophyaProg/PrgUtil/runcxx.cc
===================================================================
--- trunk/SophyaProg/PrgUtil/runcxx.cc	(revision 2609)
+++ trunk/SophyaProg/PrgUtil/runcxx.cc	(revision 2615)
@@ -1,2 +1,3 @@
+#include "sopnamsp.h"
 #include "machdefs.h"
 #include <stdio.h>
Index: trunk/SophyaProg/PrgUtil/scanfits.cc
===================================================================
--- trunk/SophyaProg/PrgUtil/scanfits.cc	(revision 2609)
+++ trunk/SophyaProg/PrgUtil/scanfits.cc	(revision 2615)
@@ -4,4 +4,5 @@
 #include <iostream>
 
+#include "sopnamsp.h"
 #include "histinit.h"
 #include "dvlist.h"
Index: trunk/SophyaProg/PrgUtil/scanppf.cc
===================================================================
--- trunk/SophyaProg/PrgUtil/scanppf.cc	(revision 2609)
+++ trunk/SophyaProg/PrgUtil/scanppf.cc	(revision 2615)
@@ -5,4 +5,5 @@
 #include <string>
 
+#include "sopnamsp.h"
 #include "ppersist.h"
 #include "anydataobj.h"
Index: trunk/SophyaProg/Tests/arrt.cc
===================================================================
--- trunk/SophyaProg/Tests/arrt.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/arrt.cc	(revision 2615)
@@ -1,2 +1,3 @@
+#include "sopnamsp.h"
 #include "machdefs.h"
 
Index: trunk/SophyaProg/Tests/carrt.cc
===================================================================
--- trunk/SophyaProg/Tests/carrt.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/carrt.cc	(revision 2615)
@@ -1,2 +1,3 @@
+#include "sopnamsp.h"
 #include "machdefs.h"
 
Index: trunk/SophyaProg/Tests/exacmplnk.cc
===================================================================
--- trunk/SophyaProg/Tests/exacmplnk.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/exacmplnk.cc	(revision 2615)
@@ -1,2 +1,3 @@
+#include "sopnamsp.h"
 #include "array.h"
 
Index: trunk/SophyaProg/Tests/fitsServTest.cc
===================================================================
--- trunk/SophyaProg/Tests/fitsServTest.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/fitsServTest.cc	(revision 2615)
@@ -4,4 +4,5 @@
 
 #include <iostream>
+#include "sopnamsp.h"
 #include "fitsioserver.h" 
 #include "tvector.h"
Index: trunk/SophyaProg/Tests/fitsioGorski.cc
===================================================================
--- trunk/SophyaProg/Tests/fitsioGorski.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/fitsioGorski.cc	(revision 2615)
@@ -2,4 +2,5 @@
 #include <iostream>
 // Utilisation de la classe LocalMap<T>
+#include "sopnamsp.h"
 #include "ntoolsinit.h"
 #include "spheregorski.h"
Index: trunk/SophyaProg/Tests/fitsioImage.cc
===================================================================
--- trunk/SophyaProg/Tests/fitsioImage.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/fitsioImage.cc	(revision 2615)
@@ -2,4 +2,5 @@
 #include <iostream>
 // Utilisation de la classe Image<T>
+#include "sopnamsp.h"
 #include "ntoolsinit.h"
 #include "cimage.h"
Index: trunk/SophyaProg/Tests/fitsioLocMap.cc
===================================================================
--- trunk/SophyaProg/Tests/fitsioLocMap.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/fitsioLocMap.cc	(revision 2615)
@@ -2,4 +2,5 @@
 #include <iostream>
 // Utilisation de la classe LocalMap<T>
+#include "sopnamsp.h"
 #include "ntoolsinit.h"
 #include "localmap.h"
Index: trunk/SophyaProg/Tests/fitsioSphere.cc
===================================================================
--- trunk/SophyaProg/Tests/fitsioSphere.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/fitsioSphere.cc	(revision 2615)
@@ -2,4 +2,5 @@
 #include <iostream>
 // Utilisation de la classe LocalMap<T>
+#include "sopnamsp.h"
 #include "ntoolsinit.h"
 #include "spheregorski.h"
Index: trunk/SophyaProg/Tests/jtcpitarr.cc
===================================================================
--- trunk/SophyaProg/Tests/jtcpitarr.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/jtcpitarr.cc	(revision 2615)
@@ -1,2 +1,3 @@
+#include "sopnamsp.h"
 #include "machdefs.h"
 #include "JTC/JTC.h"
Index: trunk/SophyaProg/Tests/jtctarr.cc
===================================================================
--- trunk/SophyaProg/Tests/jtctarr.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/jtctarr.cc	(revision 2615)
@@ -1,2 +1,3 @@
+#include "sopnamsp.h"
 #include "machdefs.h"
 #include "JTC/JTC.h"
Index: trunk/SophyaProg/Tests/lpk.cc
===================================================================
--- trunk/SophyaProg/Tests/lpk.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/lpk.cc	(revision 2615)
@@ -1,2 +1,3 @@
+#include "sopnamsp.h"
 #include "machdefs.h"
 
Index: trunk/SophyaProg/Tests/obj_fits.cc
===================================================================
--- trunk/SophyaProg/Tests/obj_fits.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/obj_fits.cc	(revision 2615)
@@ -4,4 +4,5 @@
 #include <iostream>
 
+#include "sopnamsp.h"
 #include "histinit.h"
 #include "dvlist.h"
Index: trunk/SophyaProg/Tests/ovharr.cc
===================================================================
--- trunk/SophyaProg/Tests/ovharr.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/ovharr.cc	(revision 2615)
@@ -1,2 +1,3 @@
+#include "sopnamsp.h"
 #include "machdefs.h"
 
Index: trunk/SophyaProg/Tests/pizthr.cc
===================================================================
--- trunk/SophyaProg/Tests/pizthr.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/pizthr.cc	(revision 2615)
@@ -1,2 +1,3 @@
+#include "sopnamsp.h"
 #include "machdefs.h"
 #include "zthread.h"
Index: trunk/SophyaProg/Tests/ppftswap.cc
===================================================================
--- trunk/SophyaProg/Tests/ppftswap.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/ppftswap.cc	(revision 2615)
@@ -1,2 +1,3 @@
+#include "sopnamsp.h"
 #include "sophyainit.h"
 #include "array.h"
Index: trunk/SophyaProg/Tests/spar.cc
===================================================================
--- trunk/SophyaProg/Tests/spar.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/spar.cc	(revision 2615)
@@ -1,2 +1,3 @@
+#include "sopnamsp.h"
 #include "machdefs.h"
 
Index: trunk/SophyaProg/Tests/sph2lm.cc
===================================================================
--- trunk/SophyaProg/Tests/sph2lm.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/sph2lm.cc	(revision 2615)
@@ -1,2 +1,3 @@
+#include "sopnamsp.h"
 #include "tarray.h"
 #include "cimage.h"
Index: trunk/SophyaProg/Tests/sphg0.cc
===================================================================
--- trunk/SophyaProg/Tests/sphg0.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/sphg0.cc	(revision 2615)
@@ -1,3 +1,4 @@
 #include <iostream>
+#include "sopnamsp.h"
 #include "sambainit.h"
 #include "tod.h"
Index: trunk/SophyaProg/Tests/t_scan.cc
===================================================================
--- trunk/SophyaProg/Tests/t_scan.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/t_scan.cc	(revision 2615)
@@ -3,4 +3,5 @@
 
 #include <math.h>
+#include "sopnamsp.h"
 #include "nbmath.h"
 // Utilisation de la classe Scan
Index: trunk/SophyaProg/Tests/tblitz.cc
===================================================================
--- trunk/SophyaProg/Tests/tblitz.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/tblitz.cc	(revision 2615)
@@ -1,4 +1,5 @@
 #include <stdio.h>
 #include <iostream>
+#include "sopnamsp.h"
 #include "nbrandom.h"
 #include "timing.h"
Index: trunk/SophyaProg/Tests/tcmd.cc
===================================================================
--- trunk/SophyaProg/Tests/tcmd.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/tcmd.cc	(revision 2615)
@@ -1,2 +1,3 @@
+#include "sopnamsp.h"
 #include "machdefs.h"
 #include <stdio.h>
Index: trunk/SophyaProg/Tests/tcxxcmpldynl.cc
===================================================================
--- trunk/SophyaProg/Tests/tcxxcmpldynl.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/tcxxcmpldynl.cc	(revision 2615)
@@ -4,4 +4,5 @@
 #include <iostream>
 
+#include "sopnamsp.h"
 #include "histinit.h"
 #include "array.h"
Index: trunk/SophyaProg/Tests/tdcr.cc
===================================================================
--- trunk/SophyaProg/Tests/tdcr.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/tdcr.cc	(revision 2615)
@@ -1,4 +1,5 @@
 #include <stdio.h>
 #include <stdlib.h>
+#include "sopnamsp.h"
 #include "math.h"
 #include <iostream>
Index: trunk/SophyaProg/Tests/tdynl.cc
===================================================================
--- trunk/SophyaProg/Tests/tdynl.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/tdynl.cc	(revision 2615)
@@ -5,4 +5,5 @@
 #include <fstream>
 
+#include "sopnamsp.h"
 #include "tarrinit.h"
 #include "array.h"
Index: trunk/SophyaProg/Tests/testfitsio.cc
===================================================================
--- trunk/SophyaProg/Tests/testfitsio.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/testfitsio.cc	(revision 2615)
@@ -4,4 +4,5 @@
 
 #include <iostream>
+#include "sopnamsp.h"
 #include "fitsioserver.h" 
 #include "tvector.h"
Index: trunk/SophyaProg/Tests/tfft.cc
===================================================================
--- trunk/SophyaProg/Tests/tfft.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/tfft.cc	(revision 2615)
@@ -1,2 +1,3 @@
+#include "sopnamsp.h"
 #include "machdefs.h"
 
Index: trunk/SophyaProg/Tests/thash.cc
===================================================================
--- trunk/SophyaProg/Tests/thash.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/thash.cc	(revision 2615)
@@ -4,4 +4,5 @@
 #include <iostream>
 
+#include "sopnamsp.h"
 #include "ppersist.h"
 int main(int narg, char *arg[])
Index: trunk/SophyaProg/Tests/timg.cc
===================================================================
--- trunk/SophyaProg/Tests/timg.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/timg.cc	(revision 2615)
@@ -2,4 +2,5 @@
 #include <iostream>
 // Utilisation de la classe Image<T>
+#include "sopnamsp.h"
 #include "ntoolsinit.h"
 #include "array.h"
Index: trunk/SophyaProg/Tests/tnt.cc
===================================================================
--- trunk/SophyaProg/Tests/tnt.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/tnt.cc	(revision 2615)
@@ -4,4 +4,5 @@
 #include <iostream>
 
+#include "sopnamsp.h"
 #include "histinit.h"
 #include "dvlist.h"
Index: trunk/SophyaProg/Tests/tobjio.cc
===================================================================
--- trunk/SophyaProg/Tests/tobjio.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/tobjio.cc	(revision 2615)
@@ -1,4 +1,5 @@
 #include <stdio.h>
 #include <stdlib.h>
+#include "sopnamsp.h"
 #include "math.h"
 #include <iostream>
Index: trunk/SophyaProg/Tests/tobjio2.cc
===================================================================
--- trunk/SophyaProg/Tests/tobjio2.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/tobjio2.cc	(revision 2615)
@@ -6,4 +6,5 @@
 
 // Pour le test 
+#include "sopnamsp.h"
 #include "histinit.h"
 #include "histos.h"
Index: trunk/SophyaProg/Tests/tpipe.cc
===================================================================
--- trunk/SophyaProg/Tests/tpipe.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/tpipe.cc	(revision 2615)
@@ -1,2 +1,3 @@
+#include "sopnamsp.h"
 #include "zthread.h"
 
Index: trunk/SophyaProg/Tests/tsphereecp.cc
===================================================================
--- trunk/SophyaProg/Tests/tsphereecp.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/tsphereecp.cc	(revision 2615)
@@ -1,4 +1,5 @@
 #include <stdio.h>
 #include <stdlib.h>
+#include "sopnamsp.h"
 #include "math.h"
 #include <iostream>
Index: trunk/SophyaProg/Tests/tspm.cc
===================================================================
--- trunk/SophyaProg/Tests/tspm.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/tspm.cc	(revision 2615)
@@ -1,3 +1,4 @@
 #include <iostream>
+#include "sopnamsp.h"
 #include "skymapinit.h"
 #include "skymap.h"
Index: trunk/SophyaProg/Tests/tspm2.cc
===================================================================
--- trunk/SophyaProg/Tests/tspm2.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/tspm2.cc	(revision 2615)
@@ -1,4 +1,5 @@
 #include <iostream>
 #include <math.h>
+#include "sopnamsp.h"
 #include "sambainit.h"
 #include "skymap.h"
Index: trunk/SophyaProg/Tests/tstboloread.cc
===================================================================
--- trunk/SophyaProg/Tests/tstboloread.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/tstboloread.cc	(revision 2615)
@@ -8,4 +8,5 @@
            -A pointing.fits -1 0 -B bolo.fits -3 0
 */
+#include "sopnamsp.h"
 #include "machdefs.h"
 #include <typeinfo>
Index: trunk/SophyaProg/Tests/tstcolread.cc
===================================================================
--- trunk/SophyaProg/Tests/tstcolread.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/tstcolread.cc	(revision 2615)
@@ -1,3 +1,4 @@
 // Test des classes FitsBTColRead
+#include "sopnamsp.h"
 #include "machdefs.h"
 #include <typeinfo>
Index: trunk/SophyaProg/Tests/tstndblk.cc
===================================================================
--- trunk/SophyaProg/Tests/tstndblk.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/tstndblk.cc	(revision 2615)
@@ -1,2 +1,3 @@
+#include "sopnamsp.h"
 #include "machdefs.h"
 #include <iostream>
Index: trunk/SophyaProg/Tests/tsttmat.cc
===================================================================
--- trunk/SophyaProg/Tests/tsttmat.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/tsttmat.cc	(revision 2615)
@@ -1,2 +1,3 @@
+#include "sopnamsp.h"
 #include "machdefs.h"
 #include <iostream>
Index: trunk/SophyaProg/Tests/tsttminv.cc
===================================================================
--- trunk/SophyaProg/Tests/tsttminv.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/tsttminv.cc	(revision 2615)
@@ -37,4 +37,5 @@
 
 //////////////////////////////////////////////////
+#include "sopnamsp.h"
 #include "machdefs.h"
 #include <iostream>
Index: trunk/SophyaProg/Tests/tsttvec.cc
===================================================================
--- trunk/SophyaProg/Tests/tsttvec.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/tsttvec.cc	(revision 2615)
@@ -1,2 +1,3 @@
+#include "sopnamsp.h"
 #include "machdefs.h"
 #include <iostream>
Index: trunk/SophyaProg/Tests/zthr.cc
===================================================================
--- trunk/SophyaProg/Tests/zthr.cc	(revision 2609)
+++ trunk/SophyaProg/Tests/zthr.cc	(revision 2615)
@@ -1,2 +1,3 @@
+#include "sopnamsp.h"
 #include "zthread.h"
 