Index: /trunk/SophyaLib/NTools/Makefile
===================================================================
--- /trunk/SophyaLib/NTools/Makefile	(revision 2630)
+++ /trunk/SophyaLib/NTools/Makefile	(revision 2631)
@@ -3,7 +3,7 @@
 all: $(LIB)libNTools.a
 clean:
-	rm -f $(OBJ)FSAppIrrSmpl.o $(OBJ)cimage.o $(OBJ)cspline.o $(OBJ)datatypes.o $(OBJ)dates.o $(OBJ)difeq.o $(OBJ)dynccd.o $(OBJ)fct1dfit.o $(OBJ)fct2dfit.o $(OBJ)fftmserver.o $(OBJ)fftpserver.o $(OBJ)fftservintf.o $(OBJ)generaldata.o $(OBJ)generalfit.o $(OBJ)imageop.o $(OBJ)integ.o $(OBJ)median.o $(OBJ)ntoolsinit.o $(OBJ)objfitter.o $(OBJ)perandom.o $(OBJ)poly.o $(OBJ)rk4cdifeq.o $(OBJ)simplesort.o $(OBJ)tabmath.o $(OBJ)datime.o $(OBJ)fftmayer_r4.o $(OBJ)fftmayer_r8.o $(OBJ)fftpackc.o $(OBJ)matxop.o $(OBJ)nbmath.o $(OBJ)nbtri.o
+	rm -f $(OBJ)FSAppIrrSmpl.o $(OBJ)cimage.o $(OBJ)cspline.o $(OBJ)datatypes.o $(OBJ)dates.o $(OBJ)difeq.o $(OBJ)dynccd.o $(OBJ)fct1dfit.o $(OBJ)fct2dfit.o $(OBJ)fftmserver.o $(OBJ)fftpserver.o $(OBJ)fftservintf.o $(OBJ)functab.o $(OBJ)generaldata.o $(OBJ)generalfit.o $(OBJ)imageop.o $(OBJ)integ.o $(OBJ)median.o $(OBJ)ntoolsinit.o $(OBJ)objfitter.o $(OBJ)perandom.o $(OBJ)poly.o $(OBJ)rk4cdifeq.o $(OBJ)simplesort.o $(OBJ)tabmath.o $(OBJ)datime.o $(OBJ)fftmayer_r4.o $(OBJ)fftmayer_r8.o $(OBJ)fftpackc.o $(OBJ)matxop.o $(OBJ)nbmath.o $(OBJ)nbtri.o
 	rm -f $(LIB)libNTools.a
-$(LIB)libNTools.a : $(OBJ)FSAppIrrSmpl.o $(OBJ)cimage.o $(OBJ)cspline.o $(OBJ)datatypes.o $(OBJ)dates.o $(OBJ)datime.o $(OBJ)difeq.o $(OBJ)dynccd.o $(OBJ)fct1dfit.o $(OBJ)fct2dfit.o $(OBJ)fftmayer_r4.o $(OBJ)fftmayer_r8.o $(OBJ)fftmserver.o $(OBJ)fftpackc.o $(OBJ)fftpserver.o $(OBJ)fftservintf.o $(OBJ)generaldata.o $(OBJ)generalfit.o $(OBJ)integ.o $(OBJ)matxop.o $(OBJ)median.o $(OBJ)nbmath.o $(OBJ)nbtri.o $(OBJ)ntoolsinit.o $(OBJ)objfitter.o $(OBJ)perandom.o $(OBJ)poly.o $(OBJ)rk4cdifeq.o $(OBJ)simplesort.o $(OBJ)tabmath.o
+$(LIB)libNTools.a : $(OBJ)FSAppIrrSmpl.o $(OBJ)cimage.o $(OBJ)cspline.o $(OBJ)datatypes.o $(OBJ)dates.o $(OBJ)datime.o $(OBJ)difeq.o $(OBJ)dynccd.o $(OBJ)fct1dfit.o $(OBJ)fct2dfit.o $(OBJ)fftmayer_r4.o $(OBJ)fftmayer_r8.o $(OBJ)fftmserver.o $(OBJ)fftpackc.o $(OBJ)fftpserver.o $(OBJ)fftservintf.o $(OBJ)functab.o $(OBJ)generaldata.o $(OBJ)generalfit.o $(OBJ)integ.o $(OBJ)matxop.o $(OBJ)median.o $(OBJ)nbmath.o $(OBJ)nbtri.o $(OBJ)ntoolsinit.o $(OBJ)objfitter.o $(OBJ)perandom.o $(OBJ)poly.o $(OBJ)rk4cdifeq.o $(OBJ)simplesort.o $(OBJ)tabmath.o
 	$(ARCXX) $(ARCXXFLAGS) $@ $($(ARARGS))
 ifeq ($(CXX),cxx)
@@ -11,5 +11,6 @@
 endif 
  
-$(OBJ)FSAppIrrSmpl.o: FSAppIrrSmpl.cc FSAppIrrSmpl.h \
+$(OBJ)FSAppIrrSmpl.o: FSAppIrrSmpl.cc \
+ $(INC)sopnamsp.h FSAppIrrSmpl.h \
  $(INC)machdefs.h nbmath.h \
  $(INC)smathconst.h \
@@ -25,4 +26,7 @@
  $(INC)pexceptions.h \
  $(INC)gnumd5.h \
+ $(INC)ppfbinstream.h \
+ $(INC)rawstream.h \
+ $(INC)ppfnametag.h \
  $(INC)ndatablock.h \
  $(INC)utilarr.h \
@@ -36,5 +40,6 @@
  $(INC)fftservintf.h \
  $(INC)fftpserver.h
-$(OBJ)cimage.o: cimage.cc $(INC)machdefs.h \
+$(OBJ)cimage.o: cimage.cc $(INC)sopnamsp.h \
+ $(INC)machdefs.h \
  $(INC)pexceptions.h cimage.h \
  $(INC)tmatrix.h \
@@ -47,4 +52,7 @@
  $(INC)ppersist.h \
  $(INC)gnumd5.h \
+ $(INC)ppfbinstream.h \
+ $(INC)rawstream.h \
+ $(INC)ppfnametag.h \
  $(INC)ndatablock.h \
  $(INC)utilarr.h \
@@ -52,33 +60,43 @@
  $(INC)tvector.h \
  $(INC)datatype.h
-$(OBJ)cspline.o: cspline.cc $(INC)machdefs.h \
- nbtri.h cspline.h $(INC)pexceptions.h
-$(OBJ)datatypes.o: datatypes.cc datatypes.h \
- $(INC)machdefs.h
-$(OBJ)dates.o: dates.cc $(INC)machdefs.h \
+$(OBJ)cspline.o: cspline.cc $(INC)sopnamsp.h \
+ $(INC)machdefs.h nbtri.h cspline.h \
+ $(INC)pexceptions.h
+$(OBJ)datatypes.o: datatypes.cc $(INC)sopnamsp.h \
+ datatypes.h $(INC)machdefs.h
+$(OBJ)dates.o: dates.cc $(INC)sopnamsp.h \
+ $(INC)machdefs.h \
  $(INC)perrors.h \
  $(INC)pexceptions.h dates.h
-$(OBJ)difeq.o: difeq.cc difeq.h $(INC)machdefs.h \
- $(INC)pexceptions.h \
- $(INC)tvector.h \
- $(INC)tmatrix.h \
- $(INC)tarray.h \
- $(INC)basarr.h \
- $(INC)anydataobj.h \
- $(INC)mutyv.h \
- $(INC)dvlist.h \
- $(INC)objfio.h \
- $(INC)ppersist.h \
- $(INC)gnumd5.h \
+$(OBJ)difeq.o: difeq.cc $(INC)sopnamsp.h difeq.h \
+ $(INC)machdefs.h \
+ $(INC)pexceptions.h \
+ $(INC)tvector.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)anydataobj.h \
+ $(INC)mutyv.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ppersist.h \
+ $(INC)gnumd5.h \
+ $(INC)ppfbinstream.h \
+ $(INC)rawstream.h \
+ $(INC)ppfnametag.h \
  $(INC)ndatablock.h \
  $(INC)utilarr.h \
  $(INC)ctimer.h
-$(OBJ)dynccd.o: dynccd.cc $(INC)machdefs.h fmath.h \
- perandom.h $(INC)histos.h \
- $(INC)objfio.h \
- $(INC)anydataobj.h \
- $(INC)ppersist.h \
- $(INC)pexceptions.h \
- $(INC)gnumd5.h \
+$(OBJ)dynccd.o: dynccd.cc $(INC)sopnamsp.h \
+ $(INC)machdefs.h fmath.h perandom.h \
+ $(INC)histos.h \
+ $(INC)objfio.h \
+ $(INC)anydataobj.h \
+ $(INC)ppersist.h \
+ $(INC)pexceptions.h \
+ $(INC)gnumd5.h \
+ $(INC)ppfbinstream.h \
+ $(INC)rawstream.h \
+ $(INC)ppfnametag.h \
  $(INC)peida.h \
  $(INC)utils.h \
@@ -95,16 +113,20 @@
  $(INC)srandgen.h cimage.h \
  $(INC)fioarr.h dynccd.h
-$(OBJ)fct1dfit.o: fct1dfit.cc $(INC)machdefs.h \
- fct1dfit.h generalfit.h $(INC)pexceptions.h \
- $(INC)tvector.h \
- $(INC)tmatrix.h \
- $(INC)tarray.h \
- $(INC)basarr.h \
- $(INC)anydataobj.h \
- $(INC)mutyv.h \
- $(INC)dvlist.h \
- $(INC)objfio.h \
- $(INC)ppersist.h \
- $(INC)gnumd5.h \
+$(OBJ)fct1dfit.o: fct1dfit.cc $(INC)sopnamsp.h \
+ $(INC)machdefs.h fct1dfit.h generalfit.h \
+ $(INC)pexceptions.h \
+ $(INC)tvector.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)anydataobj.h \
+ $(INC)mutyv.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ppersist.h \
+ $(INC)gnumd5.h \
+ $(INC)ppfbinstream.h \
+ $(INC)rawstream.h \
+ $(INC)ppfnametag.h \
  $(INC)ndatablock.h \
  $(INC)utilarr.h generaldata.h \
@@ -112,16 +134,20 @@
  $(INC)utils.h \
  $(INC)perrors.h fmath.h nbconst.h tabmath.h
-$(OBJ)fct2dfit.o: fct2dfit.cc $(INC)machdefs.h \
- fct2dfit.h generalfit.h $(INC)pexceptions.h \
- $(INC)tvector.h \
- $(INC)tmatrix.h \
- $(INC)tarray.h \
- $(INC)basarr.h \
- $(INC)anydataobj.h \
- $(INC)mutyv.h \
- $(INC)dvlist.h \
- $(INC)objfio.h \
- $(INC)ppersist.h \
- $(INC)gnumd5.h \
+$(OBJ)fct2dfit.o: fct2dfit.cc $(INC)sopnamsp.h \
+ $(INC)machdefs.h fct2dfit.h generalfit.h \
+ $(INC)pexceptions.h \
+ $(INC)tvector.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)anydataobj.h \
+ $(INC)mutyv.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ppersist.h \
+ $(INC)gnumd5.h \
+ $(INC)ppfbinstream.h \
+ $(INC)rawstream.h \
+ $(INC)ppfnametag.h \
  $(INC)ndatablock.h \
  $(INC)utilarr.h generaldata.h \
@@ -130,50 +156,79 @@
  $(INC)perrors.h fmath.h nbconst.h tabmath.h \
  simps2d.h
-$(OBJ)fftmserver.o: fftmserver.cc fftmserver.h fftservintf.h \
- $(INC)machdefs.h \
- $(INC)pexceptions.h \
- $(INC)tmatrix.h \
- $(INC)tarray.h \
- $(INC)basarr.h \
- $(INC)anydataobj.h \
- $(INC)mutyv.h \
- $(INC)dvlist.h \
- $(INC)objfio.h \
- $(INC)ppersist.h \
- $(INC)gnumd5.h \
+$(OBJ)fftmserver.o: fftmserver.cc $(INC)sopnamsp.h \
+ fftmserver.h fftservintf.h $(INC)machdefs.h \
+ $(INC)pexceptions.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)anydataobj.h \
+ $(INC)mutyv.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ppersist.h \
+ $(INC)gnumd5.h \
+ $(INC)ppfbinstream.h \
+ $(INC)rawstream.h \
+ $(INC)ppfnametag.h \
  $(INC)ndatablock.h \
  $(INC)utilarr.h \
  $(INC)tvector.h fftmayer.h
-$(OBJ)fftpserver.o: fftpserver.cc fftpserver.h fftservintf.h \
- $(INC)machdefs.h \
- $(INC)pexceptions.h \
- $(INC)tmatrix.h \
- $(INC)tarray.h \
- $(INC)basarr.h \
- $(INC)anydataobj.h \
- $(INC)mutyv.h \
- $(INC)dvlist.h \
- $(INC)objfio.h \
- $(INC)ppersist.h \
- $(INC)gnumd5.h \
+$(OBJ)fftpserver.o: fftpserver.cc $(INC)sopnamsp.h \
+ fftpserver.h fftservintf.h $(INC)machdefs.h \
+ $(INC)pexceptions.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)anydataobj.h \
+ $(INC)mutyv.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ppersist.h \
+ $(INC)gnumd5.h \
+ $(INC)ppfbinstream.h \
+ $(INC)rawstream.h \
+ $(INC)ppfnametag.h \
  $(INC)ndatablock.h \
  $(INC)utilarr.h \
  $(INC)tvector.h fftpackc.h
-$(OBJ)fftservintf.o: fftservintf.cc fftservintf.h \
- $(INC)machdefs.h \
- $(INC)pexceptions.h \
- $(INC)tmatrix.h \
- $(INC)tarray.h \
- $(INC)basarr.h \
- $(INC)anydataobj.h \
- $(INC)mutyv.h \
- $(INC)dvlist.h \
- $(INC)objfio.h \
- $(INC)ppersist.h \
- $(INC)gnumd5.h \
+$(OBJ)fftservintf.o: fftservintf.cc \
+ $(INC)sopnamsp.h fftservintf.h \
+ $(INC)machdefs.h \
+ $(INC)pexceptions.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)anydataobj.h \
+ $(INC)mutyv.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ppersist.h \
+ $(INC)gnumd5.h \
+ $(INC)ppfbinstream.h \
+ $(INC)rawstream.h \
+ $(INC)ppfnametag.h \
  $(INC)ndatablock.h \
  $(INC)utilarr.h \
  $(INC)tvector.h
+$(OBJ)functab.o: functab.cc $(INC)sopnamsp.h \
+ $(INC)machdefs.h \
+ $(INC)pexceptions.h functab.h \
+ $(INC)tvector.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)anydataobj.h \
+ $(INC)mutyv.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ppersist.h \
+ $(INC)gnumd5.h \
+ $(INC)ppfbinstream.h \
+ $(INC)rawstream.h \
+ $(INC)ppfnametag.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h
 $(OBJ)generaldata.o: generaldata.cc \
+ $(INC)sopnamsp.h \
  $(INC)machdefs.h \
  $(INC)strutil.h nbtri.h generalfit.h \
@@ -189,4 +244,7 @@
  $(INC)ppersist.h \
  $(INC)gnumd5.h \
+ $(INC)ppfbinstream.h \
+ $(INC)rawstream.h \
+ $(INC)ppfnametag.h \
  $(INC)ndatablock.h \
  $(INC)utilarr.h generaldata.h \
@@ -194,5 +252,6 @@
  $(INC)utils.h \
  $(INC)perrors.h fmath.h
-$(OBJ)generalfit.o: generalfit.cc $(INC)machdefs.h \
+$(OBJ)generalfit.o: generalfit.cc $(INC)sopnamsp.h \
+ $(INC)machdefs.h \
  $(INC)pexceptions.h generalfit.h \
  $(INC)tvector.h \
@@ -206,4 +265,7 @@
  $(INC)ppersist.h \
  $(INC)gnumd5.h \
+ $(INC)ppfbinstream.h \
+ $(INC)rawstream.h \
+ $(INC)ppfnametag.h \
  $(INC)ndatablock.h \
  $(INC)utilarr.h generaldata.h \
@@ -212,5 +274,6 @@
  $(INC)perrors.h fmath.h \
  $(INC)sopemtx.h
-$(OBJ)integ.o: integ.cc integ.h $(INC)machdefs.h \
+$(OBJ)integ.o: integ.cc $(INC)sopnamsp.h integ.h \
+ $(INC)machdefs.h \
  $(INC)pexceptions.h classfunc.h generalfit.h \
  $(INC)tvector.h \
@@ -224,4 +287,7 @@
  $(INC)ppersist.h \
  $(INC)gnumd5.h \
+ $(INC)ppfbinstream.h \
+ $(INC)rawstream.h \
+ $(INC)ppfnametag.h \
  $(INC)ndatablock.h \
  $(INC)utilarr.h generaldata.h \
@@ -230,6 +296,7 @@
  $(INC)perrors.h fmath.h
 $(OBJ)median.o: median.cc
-$(OBJ)ntoolsinit.o: ntoolsinit.cc $(INC)machdefs.h \
- ntoolsinit.h $(INC)tarrinit.h \
+$(OBJ)ntoolsinit.o: ntoolsinit.cc $(INC)sopnamsp.h \
+ $(INC)machdefs.h ntoolsinit.h \
+ $(INC)tarrinit.h \
  $(INC)sophyainit.h poly.h \
  $(INC)objfio.h \
@@ -237,5 +304,8 @@
  $(INC)ppersist.h \
  $(INC)pexceptions.h \
- $(INC)gnumd5.h peida.h \
+ $(INC)gnumd5.h \
+ $(INC)ppfbinstream.h \
+ $(INC)rawstream.h \
+ $(INC)ppfnametag.h peida.h \
  $(INC)utils.h \
  $(INC)perrors.h fmath.h \
@@ -251,16 +321,19 @@
  $(INC)fioarr.h tabmath.h nbconst.h dates.h \
  datime.h
-$(OBJ)objfitter.o: objfitter.cc objfitter.h \
- $(INC)machdefs.h \
- $(INC)tmatrix.h \
- $(INC)tarray.h \
- $(INC)basarr.h \
- $(INC)anydataobj.h \
- $(INC)mutyv.h \
- $(INC)dvlist.h \
- $(INC)objfio.h \
- $(INC)ppersist.h \
- $(INC)pexceptions.h \
- $(INC)gnumd5.h \
+$(OBJ)objfitter.o: objfitter.cc $(INC)sopnamsp.h \
+ objfitter.h $(INC)machdefs.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)anydataobj.h \
+ $(INC)mutyv.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ppersist.h \
+ $(INC)pexceptions.h \
+ $(INC)gnumd5.h \
+ $(INC)ppfbinstream.h \
+ $(INC)rawstream.h \
+ $(INC)ppfnametag.h \
  $(INC)ndatablock.h \
  $(INC)utilarr.h cimage.h \
@@ -275,5 +348,6 @@
  $(INC)hisprof.h generalfit.h generaldata.h \
  $(INC)ntupintf.h poly.h peida.h
-$(OBJ)perandom.o: perandom.cc $(INC)machdefs.h \
+$(OBJ)perandom.o: perandom.cc $(INC)sopnamsp.h \
+ $(INC)machdefs.h \
  $(INC)pexceptions.h perandom.h \
  $(INC)histos.h \
@@ -282,4 +356,7 @@
  $(INC)ppersist.h \
  $(INC)gnumd5.h \
+ $(INC)ppfbinstream.h \
+ $(INC)rawstream.h \
+ $(INC)ppfnametag.h \
  $(INC)peida.h \
  $(INC)utils.h \
@@ -295,10 +372,14 @@
  $(INC)utilarr.h nbrandom.h \
  $(INC)srandgen.h pemath.h
-$(OBJ)poly.o: poly.cc $(INC)machdefs.h poly.h \
- $(INC)objfio.h \
- $(INC)anydataobj.h \
- $(INC)ppersist.h \
- $(INC)pexceptions.h \
- $(INC)gnumd5.h peida.h \
+$(OBJ)poly.o: poly.cc $(INC)sopnamsp.h \
+ $(INC)machdefs.h poly.h \
+ $(INC)objfio.h \
+ $(INC)anydataobj.h \
+ $(INC)ppersist.h \
+ $(INC)pexceptions.h \
+ $(INC)gnumd5.h \
+ $(INC)ppfbinstream.h \
+ $(INC)rawstream.h \
+ $(INC)ppfnametag.h peida.h \
  $(INC)utils.h \
  $(INC)perrors.h fmath.h \
@@ -313,25 +394,31 @@
  $(INC)sopemtx.h \
  $(INC)fioarr.h
-$(OBJ)rk4cdifeq.o: rk4cdifeq.cc $(INC)machdefs.h \
- rk4cdifeq.h difeq.h $(INC)pexceptions.h \
- $(INC)tvector.h \
- $(INC)tmatrix.h \
- $(INC)tarray.h \
- $(INC)basarr.h \
- $(INC)anydataobj.h \
- $(INC)mutyv.h \
- $(INC)dvlist.h \
- $(INC)objfio.h \
- $(INC)ppersist.h \
- $(INC)gnumd5.h \
+$(OBJ)rk4cdifeq.o: rk4cdifeq.cc $(INC)sopnamsp.h \
+ $(INC)machdefs.h rk4cdifeq.h difeq.h \
+ $(INC)pexceptions.h \
+ $(INC)tvector.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)anydataobj.h \
+ $(INC)mutyv.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ppersist.h \
+ $(INC)gnumd5.h \
+ $(INC)ppfbinstream.h \
+ $(INC)rawstream.h \
+ $(INC)ppfnametag.h \
  $(INC)ndatablock.h \
  $(INC)utilarr.h \
  $(INC)ctimer.h
-$(OBJ)simplesort.o: simplesort.cc $(INC)machdefs.h \
- simplesort.h peida.h $(INC)utils.h \
+$(OBJ)simplesort.o: simplesort.cc $(INC)sopnamsp.h \
+ $(INC)machdefs.h simplesort.h peida.h \
+ $(INC)utils.h \
  $(INC)perrors.h \
  $(INC)pexceptions.h fmath.h
-$(OBJ)tabmath.o: tabmath.cc $(INC)machdefs.h \
- tabmath.h peida.h $(INC)utils.h \
+$(OBJ)tabmath.o: tabmath.cc $(INC)sopnamsp.h \
+ $(INC)machdefs.h tabmath.h peida.h \
+ $(INC)utils.h \
  $(INC)perrors.h \
  $(INC)pexceptions.h fmath.h nbconst.h
Index: /trunk/SophyaLib/NTools/objlist.list
===================================================================
--- /trunk/SophyaLib/NTools/objlist.list	(revision 2630)
+++ /trunk/SophyaLib/NTools/objlist.list	(revision 2631)
@@ -15,4 +15,5 @@
 fftpserver.o
 fftservintf.o
+functab.o
 generaldata.o
 generalfit.o