Index: /trunk/SophyaLib/Samba/Makefile
===================================================================
--- /trunk/SophyaLib/Samba/Makefile	(revision 2643)
+++ /trunk/SophyaLib/Samba/Makefile	(revision 2644)
@@ -3,7 +3,7 @@
 all: $(LIB)libSamba.a
 clean:
-	rm -f $(OBJ)alm.o $(OBJ)bruit.o $(OBJ)circle.o $(OBJ)datacirclefake.o $(OBJ)lambdaBuilder.o $(OBJ)mlobe.o $(OBJ)sambainit.o $(OBJ)scan.o $(OBJ)sphericaltransformserver.o
+	rm -f $(OBJ)alm.o $(OBJ)bruit.o $(OBJ)circle.o $(OBJ)datacirclefake.o $(OBJ)harmspher.o $(OBJ)lambdaBuilder.o $(OBJ)mlobe.o $(OBJ)sambainit.o $(OBJ)scan.o $(OBJ)sphericaltransformserver.o
 	rm -f $(LIB)libSamba.a
-$(LIB)libSamba.a : $(OBJ)alm.o $(OBJ)bruit.o $(OBJ)circle.o $(OBJ)datacirclefake.o $(OBJ)lambdaBuilder.o $(OBJ)mlobe.o $(OBJ)sambainit.o $(OBJ)scan.o $(OBJ)sphericaltransformserver.o
+$(LIB)libSamba.a : $(OBJ)alm.o $(OBJ)bruit.o $(OBJ)circle.o $(OBJ)datacirclefake.o $(OBJ)harmspher.o $(OBJ)lambdaBuilder.o $(OBJ)mlobe.o $(OBJ)sambainit.o $(OBJ)scan.o $(OBJ)sphericaltransformserver.o
 	$(ARCXX) $(ARCXXFLAGS) $@ $($(ARARGS))
 ifeq ($(CXX),cxx)
@@ -11,5 +11,6 @@
 endif 
  
-$(OBJ)alm.o: alm.cc alm.h $(INC)nbrandom.h \
+$(OBJ)alm.o: alm.cc $(INC)sopnamsp.h \
+ alm.h $(INC)nbrandom.h \
  $(INC)srandgen.h \
  $(INC)machdefs.h \
@@ -29,21 +30,33 @@
  $(INC)ppersist.h \
  $(INC)gnumd5.h \
+ $(INC)ppfbinstream.h \
+ $(INC)rawstream.h \
+ $(INC)ppfnametag.h \
  $(INC)utilarr.h
-$(OBJ)bruit.o: bruit.cc $(INC)fmath.h bruit.h \
+$(OBJ)bruit.o: bruit.cc \
+ $(INC)sopnamsp.h \
+ $(INC)fmath.h bruit.h \
  $(INC)nbrandom.h \
  $(INC)srandgen.h \
  $(INC)machdefs.h
-$(OBJ)circle.o: circle.cc circle.h $(INC)vector3d.h \
+$(OBJ)circle.o: circle.cc \
+ $(INC)sopnamsp.h circle.h \
+ $(INC)vector3d.h \
  $(INC)longlat.h \
  $(INC)machdefs.h \
  $(INC)utilgeom.h \
  $(INC)unitvector.h geometry.h
-$(OBJ)datacirclefake.o: datacirclefake.cc datacirclefake.h datacirclebase.h \
- circle.h $(INC)vector3d.h \
+$(OBJ)datacirclefake.o: datacirclefake.cc \
+ $(INC)sopnamsp.h \
+ datacirclefake.h datacirclebase.h circle.h \
+ $(INC)vector3d.h \
  $(INC)longlat.h \
  $(INC)machdefs.h \
  $(INC)utilgeom.h \
  $(INC)unitvector.h geometry.h
-$(OBJ)lambdaBuilder.o: lambdaBuilder.cc lambdaBuilder.h \
+$(OBJ)harmspher.o: harmspher.cc \
+ $(INC)machdefs.h harmspher.h
+$(OBJ)lambdaBuilder.o: lambdaBuilder.cc \
+ $(INC)sopnamsp.h lambdaBuilder.h \
  $(INC)ndatablock.h \
  $(INC)machdefs.h \
@@ -59,4 +72,7 @@
  $(INC)pexceptions.h \
  $(INC)gnumd5.h \
+ $(INC)ppfbinstream.h \
+ $(INC)rawstream.h \
+ $(INC)ppfnametag.h \
  $(INC)utilarr.h alm.h \
  $(INC)nbrandom.h \
@@ -66,5 +82,6 @@
  $(INC)triangmtx.h \
  $(INC)nbconst.h
-$(OBJ)mlobe.o: mlobe.cc mlobe.h \
+$(OBJ)mlobe.o: mlobe.cc \
+ $(INC)sopnamsp.h mlobe.h \
  $(INC)sphericalmap.h \
  $(INC)smathconst.h \
@@ -74,4 +91,7 @@
  $(INC)pexceptions.h \
  $(INC)gnumd5.h \
+ $(INC)ppfbinstream.h \
+ $(INC)rawstream.h \
+ $(INC)ppfnametag.h \
  $(INC)dvlist.h \
  $(INC)objfio.h \
@@ -90,5 +110,6 @@
  $(INC)utilarr.h \
  $(INC)timing.h
-$(OBJ)sambainit.o: sambainit.cc sambainit.h \
+$(OBJ)sambainit.o: sambainit.cc \
+ $(INC)sopnamsp.h sambainit.h \
  $(INC)skymapinit.h \
  $(INC)sophyainit.h \
@@ -96,8 +117,12 @@
  $(INC)ntoolsinit.h \
  $(INC)tarrinit.h
-$(OBJ)scan.o: scan.cc $(INC)machdefs.h scan.h \
+$(OBJ)scan.o: scan.cc $(INC)sopnamsp.h \
+ $(INC)machdefs.h scan.h \
  $(INC)ppersist.h \
  $(INC)pexceptions.h \
  $(INC)gnumd5.h \
+ $(INC)ppfbinstream.h \
+ $(INC)rawstream.h \
+ $(INC)ppfnametag.h \
  $(INC)dvlist.h \
  $(INC)objfio.h \
@@ -108,5 +133,7 @@
  $(INC)smathconst.h
 $(OBJ)sphericaltransformserver.o: sphericaltransformserver.cc \
- $(INC)machdefs.h sphericaltransformserver.h \
+ $(INC)sopnamsp.h \
+ $(INC)machdefs.h \
+ sphericaltransformserver.h \
  $(INC)sphericalmap.h \
  $(INC)smathconst.h \
@@ -115,4 +142,7 @@
  $(INC)pexceptions.h \
  $(INC)gnumd5.h \
+ $(INC)ppfbinstream.h \
+ $(INC)rawstream.h \
+ $(INC)ppfnametag.h \
  $(INC)dvlist.h \
  $(INC)objfio.h \
@@ -135,4 +165,4 @@
  $(INC)srandgen.h \
  $(INC)nbmath.h \
- $(INC)triangmtx.h lambdaBuilder.h \
- $(INC)timing.h
+ $(INC)triangmtx.h \
+ lambdaBuilder.h $(INC)timing.h
Index: /trunk/SophyaLib/Samba/objlist.list
===================================================================
--- /trunk/SophyaLib/Samba/objlist.list	(revision 2643)
+++ /trunk/SophyaLib/Samba/objlist.list	(revision 2644)
@@ -3,4 +3,5 @@
 circle.o
 datacirclefake.o
+harmspher.o
 lambdaBuilder.o
 mlobe.o